Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
smpirun: cleanup files and children before dying
[simgrid.git] / src / smpi / smpirun.in
index 2cd37fc..e9e2b43 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Copyright (c) 2007-2014. The SimGrid Team.
+# Copyright (c) 2007-2015. The SimGrid Team.
 # All rights reserved.
 
 # This program is free software; you can redistribute it and/or modify it
@@ -8,6 +8,9 @@
 
 @CMAKE_SMPI_COMMAND@
 
+SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
+SIMGRID_GITHASH="@SIMGRID_GITHASH@"
+
 DEFAULT_LOOPBACK_BANDWIDTH="498000000"
 DEFAULT_LOOPBACK_LATENCY="0.000004"
 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))"
@@ -21,7 +24,7 @@ NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
 POWER="${DEFAULT_POWER}"
 
-SIMOPTS="--cfg=maxmin/precision:1e-3 --cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304"
+SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304"
 
 #usage to print the way this script should be called
 usage () {
@@ -42,6 +45,9 @@ Options:
   -trace-viva                # generate configuration for Viva's GraphView
   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
   -ext <value>               # additional parameter (reserved)
+  
+  -version                   # Displays the SimGrid version (human readable)
+  -git-version               # Displays the git hash of SimGrid
 
 or (deprecated usage):
   $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
@@ -59,6 +65,44 @@ fi
 EXTOPT=""
 WRAPPER=""
 HOSTFILE=""
+HOSTFILETMP=0
+
+unset pid
+
+smpirun_cleanup()
+{
+  if [ -z "${KEEP}" ] ; then
+      if [ -z "${PLATFORM}" -a -n "$PLATFORMTMP" ]; then
+        rm -f ${PLATFORMTMP}
+        PLATFORMTMP=""
+      fi
+      if [ ${HOSTFILETMP} = 1 -a -n "$HOSTFILE" ] ; then
+          rm -f ${HOSTFILE}
+          HOSTFILE=""
+      fi
+      if [ ${UNROLLEDHOSTFILETMP} = 1 -a -n "$UNROLLEDHOSTFILE" ] ; then
+          rm -f ${UNROLLEDHOSTFILE}
+          UNROLLEDHOSTFILE=""
+      fi
+      if [ -n ${APPLICATIONTMP} ]; then
+        rm -f ${APPLICATIONTMP}
+        APPLICATIONTMP=""
+      fi
+  fi
+}
+
+smpirun_trap() {
+  smpirun_cleanup
+  if ! [ -z "$pid" ]; then
+    kill -TERM $pid
+  fi
+  unset pid
+  trap - HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS
+  kill -TERM $$
+  exit 128
+}
+
+trap smpirun_trap HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS
 
 while true; do
     case "$1" in
@@ -77,7 +121,7 @@ while true; do
         "-platform")
            PLATFORM="$2"
             if [ ! -f "${PLATFORM}" ]; then
-               echo "[$0] ** error: the file '${PLATFORM}' does not exist. Aborting."
+               echo "[`basename $0`] ** error: the file '${PLATFORM}' does not exist. Aborting."
                exit 1
             fi
            shift 2
@@ -85,7 +129,7 @@ while true; do
         "-hostfile")
            HOSTFILE="$2"
             if [ ! -f "${HOSTFILE}" ]; then
-               echo "[$0] ** error: the file '${HOSTFILE}' does not exist. Aborting."
+               echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
                exit 1
             fi
            shift 2
@@ -94,7 +138,7 @@ while true; do
         "-machinefile")
            HOSTFILE="$2"
             if [ ! -f "${HOSTFILE}" ]; then
-               echo "[$0] ** error: the file '${HOSTFILE}' does not exist. Aborting."
+               echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
                exit 1
             fi
            shift 2
@@ -163,7 +207,17 @@ while true; do
 
         "-help" | "--help" | "-h")
             usage
-            exit
+            exit 0
+            ;;
+
+        "-version" | "--version" | "-v")
+            printf '%b\n' "$SIMGRID_VERSION"
+            exit 0
+            ;;
+           
+        "-git-version" | "--git-version")
+            printf '%b\n' "$SIMGRID_GITHASH"
+            exit 0
             ;;
 
         "--cfg="*|"--log="*)
@@ -213,11 +267,24 @@ if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
     exit 1
 fi
 
-HOSTFILETMP=0
 if [ -z "${HOSTFILE}" ] ; then
     HOSTFILETMP=1
     HOSTFILE="$(mktemp tmphostXXXXXX)"
     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
+    perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
+                my ($pre,$rad,$post)=($1,$2,$3); 
+               for my $elm (split(",",$rad)) { 
+                 if ($elm=~/^([^-]*?)-([^-]*)$/) { 
+                    for (my $i=$1; $i<=$2;$i++) { 
+                       print "$pre$i$post\n"; 
+                    }
+                 } else {
+                    print "$pre$elm$post\n";
+                 }
+               }
+             } elsif (/<cluster/) {
+               die ("Unparsable cluster tag. Either provide an hostfile yourself or give the attributes prefix, radical and suffix in that order on the <cluster line");
+             }' ${PLATFORM} >> ${HOSTFILE}
 fi
 UNROLLEDHOSTFILETMP=0
 
@@ -237,6 +304,10 @@ fi
 
 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
 hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
+if [ ${hostfile_procs} = 0 ] ; then
+   echo "[`basename $0`] ** error: the hostfile '${HOSTFILE}' is empty. Aborting." >&2
+   exit 1
+fi
 
 if [ -z "${NUMPROCS}" ] ; then
     # Use the amount of processes in the hostfile as default value for the -np parameter
@@ -332,9 +403,9 @@ if [ -n "${HAVE_SEQ}" ]; then
     SEQ=`${HAVE_SEQ} 0 $((${NUMPROCS}-1))`
 else
     cnt=0
-    while (( $cnt < ${NUMPROCS} )) ; do
-       SEQ="$SEQ $cnt"
-       cnt=$((cnt + 1));
+    while [ $cnt -lt ${NUMPROCS} ] ; do
+        SEQ="$SEQ $cnt"
+        cnt=$((cnt + 1));
     done
 fi
 
@@ -424,20 +495,12 @@ if [ -n "${KEEP}" ] ; then
         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} keeped." 
     fi
 fi
-${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
+${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} &
+pid=$!
+wait $pid
 status=$?
+pid=""
 
-if [ -z "${KEEP}" ] ; then
-    if [ -z "${PLATFORM}" ]; then
-       rm ${PLATFORMTMP}
-    fi
-    if [ ${HOSTFILETMP} = 1 ] ; then
-        rm ${HOSTFILE}
-    fi
-    if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
-        rm ${UNROLLEDHOSTFILE}
-    fi
-    rm ${APPLICATIONTMP}
-fi
+smpirun_cleanup
 
 exit $status